
#include <string.h>
#include <demo.h>
#include <dolphin.h>
#include <dolphin/os.h>
#include <ppcarch.h>

#include "controller.h"
#include "debug.c"
#include "controller.c"

// ****************************************************************************************************************
// main
// ****************************************************************************************************************

int main(void)
{
ControllerInfo Controllers[4];
int i,err;

	// Init the OS, game pad, graphics and video.
    OSInit();
    VIInit();

    // init console
    conio_init();
    conio_foreground();
    conio_enable_backscroll();
    cursor(1);clrscr();

    OSEnableInterrupts();

    ControllerInit(Controllers);

	while(1)
    {
        clrscr(); gotoxy(0,5);

        err=ControllerRead(Controllers);

        for(i=0;i<4;i++)
        {
          gotoxy(0,26+i);
          if(Controllers[i].raw.errstat)
          {
              cprintf("[err] ");
              ControllerReInit(Controllers);
          }
          if(Controllers[i].raw.errlatch)
          {
              cprintf("[errlatch] ");
              ControllerReInit(Controllers);
          }
          switch(Controllers[i].id)
          {
            case CID_STD:
                  cprintf("(std pad)     ");
                  cprintf("stat:%02x ",Controllers[i].status);

                  //cprintf("%08x %08x ",Controllers[i].raw.word[0],Controllers[i].raw.word[1]);

                  cprintf("%4d ",Controllers[i].pad.ax);
                  cprintf("%4d ",Controllers[i].pad.ay);

                  cprintf("%4d ",Controllers[i].pad.cx);
                  cprintf("%4d ",Controllers[i].pad.cy);

                  cprintf("%4d ",Controllers[i].pad.al);
                  cprintf("%4d ",Controllers[i].pad.ar);

                  if(Controllers[i].pad.a)
                  {
                      cprintf("A ");
                      ControllerRumble(Controllers,i,1);
                  }
                  if(Controllers[i].pad.b)
                  {
                      cprintf("B ");
                      ControllerRumble(Controllers,i,0);
                  }
                  if(Controllers[i].pad.x)
                  {
                      cprintf("X ");
                  }
                  if(Controllers[i].pad.y)
                  {
                      cprintf("Y ");
                  }

                  if(Controllers[i].pad.s)
                  {
                      cprintf("Start ");
                      ControllerInit(Controllers);
                  }

                  if(Controllers[i].pad.lt)
                  {
                      cprintf("L ");
                  }
                  if(Controllers[i].pad.rt)
                  {
                      cprintf("R ");
                  }
                  if(Controllers[i].pad.z)
                  {
                      cprintf("Z ");
                  }

                  if(Controllers[i].pad.u)
                  {
                      cprintf("up ");
                  }
                  if(Controllers[i].pad.d)
                  {
                      cprintf("down ");
                  }
                  if(Controllers[i].pad.r)
                  {
                      cprintf("left ");
                  }
                  if(Controllers[i].pad.l)
                  {
                      cprintf("right ");
                  }
                break;
            case CID_GBA:
                  cprintf("(gba)         ");
                  cprintf("stat:%02x ",Controllers[i].status);
                break;
            case CID_GBA_NA:
                  cprintf("(gba) n/a     ");
                  cprintf("stat:%02x ",Controllers[i].status);
                break;
            case CID_KEYB:
                  cprintf("(gc keyboard) ");
                  cprintf("stat:%02x ",Controllers[i].status);
                  cprintf("%08x %08x ",Controllers[i].raw1,Controllers[i].raw2);
                  cprintf("%02x %02x %02x ",Controllers[i].keyb.key[0],Controllers[i].keyb.key[1],Controllers[i].keyb.key[2]);
                break;
            default:
                  cprintf("(none/unknown) ");
                  cprintf("id:%04x ",Controllers[i].id);
                  cprintf("stat:%02x ",Controllers[i].status);
                break;
          }
          cprintf("\n");
       }

       conio_update();
	}

    return(0);
}

